import { Layout, Txt, makeScene2D } from "@motion-canvas/2d";
import { Direction, beginSlide, slideTransition } from "@motion-canvas/core";
import { theme } from "../theme";

export default makeScene2D(function* (view) {
  view.add(
    <Layout layout direction="column" alignItems="center">
      <Txt fontSize={40} fontFamily={theme.font} fill={theme.text.hex}>
        Questions?
      </Txt>
    </Layout>
  );

  yield* slideTransition(Direction.Right);
  yield* beginSlide("Questions");
});
